﻿using UnityEngine;
using HarmonyLib;
using System.Reflection;
using System.Linq;

[HarmonyPatch(typeof(PlayerStats)), HarmonyPatch("Consume")]
internal class ConsumePatch
{
	static void Postfix(PlayerStats __instance, Item_Base edibleItem)
	{
		if (__instance.GetComponent(typeof(Network_Player)) == RAPI.GetLocalPlayer())
		{
			ComponentManager<WeWantPlatesAlsoCups>.Value.OnConsumeItem(edibleItem);
		}
	}
}

// Man, fuckin' milk buckets for days. Just gonna disable this for now to get the glass patch out.
/*
[HarmonyPatch(typeof(CookingTable)), HarmonyPatch("HandleStartCooking")]
internal class CookingTablePatch
{
	static void Postfix(CookingTable __instance)
	{
		var current_recipe = Traverse.Create(__instance).Field("currentRecipe").GetValue() as SO_CookingTable_Recipe;
		if (current_recipe != null)
        {
			Debug.Log("___currentRecipe: " + current_recipe.Result.UniqueName);
			if (Raft_Network.IsHost || !Raft_Network.IsHost)
            {
				if (current_recipe.Result.UniqueName == "Claybowl_HeadBroth")
				{
					RAPI.GiveItem(ItemManager.GetItemByName("Bucket"), 1);
				}
			}
		}
	}
}*/

/*
[HarmonyPatch(typeof(CookingTable)), HarmonyPatch("StartCooking")]
internal class CookingTablePatch
{
	static void Prefix(CookingTable __instance, SO_CookingTable_Recipe recipe)
	{
		if (recipe != null && __instance.CanStartCooking())
        {
			if (__instance.localPlayer != null)
			{
				//var message = new Message_Item((Messages)WeWantMessages.Pick_Up_Item, player, ItemManager.GetItemByName("Bucket"));

				foreach (var _ in __instance.Slots.Where(cooking_slot => cooking_slot.CurrentItem.UniqueName == "Bucket_Milk"))
				{
					//RAPI.GetLocalPlayer().Network.RPC(message, Target.All, Steamworks.EP2PSend.k_EP2PSendReliable, (NetworkChannel)20001);
					RAPI.GiveItem(ItemManager.GetItemByName("Bucket"), 1);
				}
			}
		}
	}

	static void Postfix(CookingTable __instance)
	{
		
		var player = __instance.localPlayer;
		var network = Traverse.Create(__instance).Field("network").GetValue() as Raft_Network;

		if (player != null)
		{
			var message = new Message_Item((Messages)WeWantMessages.Pick_Up_Item, player, ItemManager.GetItemByName("Bucket"));

			foreach (var _ in __instance.Slots.Where(cooking_slot => cooking_slot.CurrentItem.UniqueName == "Bucket_Milk"))
			{
				RAPI.GetLocalPlayer().Network.RPC(message, Target.All, Steamworks.EP2PSend.k_EP2PSendReliable, (NetworkChannel)20001);
			}
		}
	}
}
*/

[HarmonyPatch(typeof(Tank)), HarmonyPatch("ModifyTank")]
internal class ModifyTankPatch
{
	static void Postfix(Tank __instance, Network_Player player, float amount, Item_Base itemType)
	{
		if (player != null && player.IsLocalPlayer)
        {
			if (itemType != null && itemType.UniqueName == "Jar_Honey")
			{
				RAPI.GiveItem(ItemManager.GetItemByName("Glass"), 1);
			}
		}
	}
}

public class WeWantPlatesAlsoCups : Mod
{
	private Harmony harmony;
	private string harmony_id = "WeWantPlatesAlsoCups";
	
	public void Start()
	{
		Debug.Log("Loading \"We Want Plates... Also Cups.\".");
		ComponentManager<WeWantPlatesAlsoCups>.Value = this;

		harmony = new Harmony(harmony_id);
		harmony.PatchAll(Assembly.GetExecutingAssembly());

		FixRecipes();
		Debug.Log("Mod \"We Want Plates... Also Cups.\" has been loaded!");
	}

	public void OnModUnload()
	{
		harmony.UnpatchAll(harmony_id);
		UnFixRecipes();
		Debug.Log("Mod \"We Want Plates... Also Cups.\" has been unloaded!");
	}

	public void OnConsumeItem(Item_Base item)
	{
		var item_name = (item.name.ToLower().Contains("claybowl") || item.name.ToLower().Contains("clayplate")) ? "claybowl" : item.name;
		item_name = item.name.ToLower().Contains("drinkingglass_") ? "drinkingglass" : item_name;
		item_name = item.name.ToLower().Contains("jar_honey") ? "honey" : item_name;

		switch (item_name)
		{
			case "claybowl":
				RAPI.GetLocalPlayer().Inventory.AddItem(ItemManager.GetItemByName("Claybowl_Empty").UniqueName, 1);
				break;

			case "drinkingglass":
				RAPI.GetLocalPlayer().Inventory.AddItem(ItemManager.GetItemByName("DrinkingGlass").UniqueName, 1);
				break;

			case "honey":
				RAPI.GetLocalPlayer().Inventory.AddItem(ItemManager.GetItemByName("Glass").UniqueName, 1);
				break;

			default:
				break;
		}
	}

	public void FixRecipes()
	{
		var glass = ItemManager.GetItemByName("Glass");
		var honeycomb = ItemManager.GetItemByName("HoneyComb");
		var clay = ItemManager.GetItemByName("Clay");
		var sand = ItemManager.GetItemByName("Sand");
		var drinking_glass = ItemManager.GetItemByName("DrinkingGlass");
		var honey_jar = ItemManager.GetItemByName("Jar_Honey");
		var clay_bowl = ItemManager.GetItemByName("Claybowl_Empty");

		var drinking_glass_glass = new CostMultiple(new Item_Base[] { glass }, 4);
		var drinking_class_cost = new CostMultiple[] { drinking_glass_glass };
		SetRecipe(drinking_glass, drinking_class_cost, CraftingCategory.FoodWater, 4);
		Debug.Log("Adjusting Drinking Glass recipe.");

		var honey_jar_glass = new CostMultiple(new Item_Base[] { glass }, 2);
		var honey_jar_comb = new CostMultiple(new Item_Base[] { honeycomb }, 6);
		var honey_jar_cost = new CostMultiple[] { honey_jar_comb, honey_jar_glass };
		SetRecipe(honey_jar, honey_jar_cost, CraftingCategory.Resources, 2);
		Debug.Log("Adjusting Honey recipe.");

		var clay_bowl_clay = new CostMultiple(new Item_Base[] { clay }, 8);
		var clay_bowl_cost = new CostMultiple[] { clay_bowl_clay };
		SetRecipe(clay_bowl, clay_bowl_cost, CraftingCategory.FoodWater, 4);
		Debug.Log("Adjusting Clay Bowl recipe.");
	}

	public void UnFixRecipes()
	{
		var glass = ItemManager.GetItemByName("Glass");
		var honeycomb = ItemManager.GetItemByName("HoneyComb");
		var clay = ItemManager.GetItemByName("Clay");

		var drinking_glass = ItemManager.GetItemByName("DrinkingGlass");
		var drinking_glass_glass = new CostMultiple(new Item_Base[] { glass }, 1);
		var drinking_class_cost = new CostMultiple[] { drinking_glass_glass };
		SetRecipe(drinking_glass, drinking_class_cost, CraftingCategory.FoodWater, 4);
		Debug.Log("Returning Drinking Glass recipe to default.");

		var honey_jar = ItemManager.GetItemByName("Jar_Honey");
		var honey_jar_glass = new CostMultiple(new Item_Base[] { glass }, 1);
		var honey_jar_comb = new CostMultiple(new Item_Base[] { honeycomb }, 6);
		var honey_jar_cost = new CostMultiple[] { honey_jar_comb, honey_jar_glass };
		SetRecipe(honey_jar, honey_jar_cost, CraftingCategory.Resources, 2);
		Debug.Log("Returning Honey recipe to default.");

		var clay_bowl = ItemManager.GetItemByName("Claybowl_Empty");
		var clay_bowl_clay = new CostMultiple(new Item_Base[] { clay }, 2);
		var clay_bowl_cost = new CostMultiple[] { clay_bowl_clay };
		SetRecipe(clay_bowl, clay_bowl_cost, CraftingCategory.FoodWater, 4);
		Debug.Log("Returning Clay Bowl recipe to default.");
	}

	public void SetRecipe(Item_Base item, CostMultiple[] cost, CraftingCategory category, int amountToCraft = 1, bool learnedFromBeginning = false)
	{
		Traverse.Create(item.settings_recipe).Field("craftingCategory").SetValue(category);
		Traverse.Create(item.settings_recipe).Field("amountToCraft").SetValue(amountToCraft);
		Traverse.Create(item.settings_recipe).Field("learnedFromBeginning").SetValue(learnedFromBeginning);
		item.settings_recipe.NewCost = cost;
	}

	/*
	public void Update()
	{
		NetworkMessage network_message = RAPI.ListenForNetworkMessagesOnChannel(20001);
		if (network_message != null)
		{
			var CSteamID = network_message.steamid;
			var local_player_id = RAPI.GetLocalPlayer().steamID;
			Message message = network_message.message;
			Debug.Log("Sender: " + CSteamID + " Local: " + local_player_id);
			if (message.Type == (Messages)WeWantMessages.Pick_Up_Item)
			{
				Message_Item msg = message as Message_Item;
				
				if (CSteamID == local_player_id)
                {
					Debug.Log("I got my own message! Spawning a damn bucket. Nobody else gets one.");
					RAPI.GiveItem(ItemManager.GetItemByIndex(msg.itemIndex), 1);
				}
			}
		}
	}*/
}